/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "asteriod.hpp"
#include "koule.hpp"

int asteroid_textura1 = 0;
int asteroid_textura2 = 0;

int InitAsteroidy() {
    aBitmapGL bitmap;
    
    bitmap.load("data/ast1.aBitmap");
    asteroid_textura1 = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/ast2.aBitmap");
    asteroid_textura2 = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawAsteroid(float distance, int typ, float size) {
    if (distance < 100.0) distance = 100.0;
    float vertdiv = 100.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    if (vertdiv < 0.1) return 0;
    
    glPushAttrib(GL_ENABLE_BIT);
    glEnable(GL_TEXTURE_2D);
    
    glBindTexture(GL_TEXTURE_2D, asteroid_textura1);
    DrawSphere(size, 5, 5);

    glPopAttrib();
    
    return 0;
};

