/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "charon.hpp"
#include "koule.hpp"

int charon_textura = 0;

int InitCharon() {
    aBitmapGL bitmap;
    
    bitmap.load("data/charon.aBitmap");
    charon_textura = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawCharon(float distance, int t) {
    if (distance < 500.0) distance = 500.0;
    float vertdiv = 500.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);
    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, charon_textura);
    glDisable(GL_BLEND);

    glRotatef(90.0, -1.0, 0.0, 0.0);
    glColor4f(1.0,1.0,1.0,1.0);
    DrawSphere(0.6, (int)(30*vertdiv), (int)(30*vertdiv));
    
    glPopAttrib();
    return 0;
};
