/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "galaxie.hpp"

int galaxie_textura;

int InitGalaxy(aBitmapGL* gr) {
    galaxie_textura = gr->getOpenGLTexture();
    return 0;
};

int DrawGalaxy() {
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);

    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glEnable(GL_BLEND);

    glDisable(GL_DEPTH_TEST);
    glEnable(GL_TEXTURE_2D);
    glDisable(GL_LIGHTING);
    glColor3f(0.2,0.2,0.2);

    glBindTexture(GL_TEXTURE_2D, galaxie_textura);
    glBegin(GL_QUADS);
        for (int i=0; i<36; ++i) {
            float x1 = 1000.0*sin(2.0*PI*(i/36.0));
            float y1 = 1000.0*cos(2.0*PI*(i/36.0));
            float x2 = 1000.0*sin(2.0*PI*((i+1)/36.0));
            float y2 = 1000.0*cos(2.0*PI*((i+1)/36.0));
            
            VECTOR3D vec[4] = {
                { x1,-1300.0, y1 },
                { x1, 1300.0, y1 },
                { x2, 1300.0, y2 },
                { x2,-1300.0, y2 }
            };
            
            if (frustum.RectInFrustum(vec)) {
        		glTexCoord2f((i+0)/36.0f, 0.0f); glVertex3fv( (GLfloat*)&vec[0] );
    	        glTexCoord2f((i+0)/36.0f, 1.0f); glVertex3fv( (GLfloat*)&vec[1] );
        	    glTexCoord2f((i+1)/36.0f, 1.0f); glVertex3fv( (GLfloat*)&vec[2] ); 
    	        glTexCoord2f((i+1)/36.0f, 0.0f); glVertex3fv( (GLfloat*)&vec[3] );
	        }
		}
    glEnd();


    glPopAttrib();    
    return 0;
};

