/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "hvezda.hpp"
#include "koule.hpp"

namespace hvezda_cpp {
    VECTOR3D tc[6][4] = {
        {
            { 0.0f, 0.0f },
            { 0.0f, 1.0f },
            { 1.0f, 1.0f },
            { 1.0f, 0.0f }
        },
        {
            { 1.0f, 0.0f },
            { 1.0f, 1.0f },
            { 0.0f, 1.0f },
            { 0.0f, 0.0f }
        },
        {
            { 1.0f, 0.0f },
            { 0.0f, 0.0f },
            { 0.0f, 1.0f },
            { 1.0f, 1.0f }
        },
        {
            { 0.0f, 0.0f },
            { 1.0f, 0.0f },
            { 1.0f, 1.0f },
            { 0.0f, 1.0f }
        },
        {
            { 0.0f, 1.0f },
            { 1.0f, 1.0f },
            { 1.0f, 0.0f },
            { 0.0f, 0.0f }
        },
        {
            { 1.0f, 0.0f },
            { 1.0f, 1.0f },
            { 0.0f, 1.0f },
            { 0.0f, 0.0f }
        }
    };
    VECTOR3D strana[6][4] = {
        {
            { -2000.0, -2000.0, -2000.0 },
            { -2000.0,  2000.0, -2000.0 },
            {  2000.0,  2000.0, -2000.0 },
            {  2000.0, -2000.0, -2000.0 }
        },
        {
            { -2000.0, -2000.0,  2000.0 },
            { -2000.0,  2000.0,  2000.0 },
            {  2000.0,  2000.0,  2000.0 },
            {  2000.0, -2000.0,  2000.0 }
        },
        {
            { -2000.0, -2000.0, -2000.0 },
            { -2000.0, -2000.0,  2000.0 },
            { -2000.0,  2000.0,  2000.0 },
            { -2000.0,  2000.0, -2000.0 }
        },
        {
            {  2000.0, -2000.0, -2000.0 },
            {  2000.0, -2000.0,  2000.0 },
            {  2000.0,  2000.0,  2000.0 },
            {  2000.0,  2000.0, -2000.0 }
        },

        {
            { -2000.0,  2000.0, -2000.0 },
            { -2000.0,  2000.0,  2000.0 },
            {  2000.0,  2000.0,  2000.0 },
            {  2000.0,  2006.0, -2000.0 }
        },
        {
            { -2000.0, -2000.0, -2000.0 },
            { -2000.0, -2000.0,  2000.0 },
            {  2000.0, -2000.0,  2000.0 },
            {  2000.0, -2000.0, -2000.0 }
        }
    };
}
using namespace hvezda_cpp;

int stars_texture = 0;

int InitStars(aBitmapGL *gr) {
    stars_texture = gr->getOpenGLTexture();
    return 0;
};

int PaintStars() {
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);

    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glDisable(GL_DEPTH_TEST);
    glEnable(GL_TEXTURE_2D);
    glDisable(GL_LIGHTING);
    glEnable(GL_BLEND);
    glColor3f(1.0,1.0,1.0);
    
    glBindTexture(GL_TEXTURE_2D, stars_texture);
    glBegin(GL_QUADS);
        for (int i=0; i<6; ++i) {
            if (frustum.RectInFrustum(strana[i])) {
                for (int m=0; m<2; ++m) {
                    if (m == 0)
                        glDisable(GL_BLEND);
                    else
                        glEnable(GL_BLEND);
                
                    for (int j=0; j<4; ++j) {
                        if (m)
                    		glTexCoord2f(tc[i][j].x, tc[i][j].y);
                		else
                    		glTexCoord2f(3.0*tc[i][j].x, 3.0*tc[i][j].y);
                    		
                        glVertex3fv((GLfloat*)&strana[i][j]);
                    } //j
                }
    		} // rect in
		} // i
    glEnd();
    
    glPopAttrib();
    return 0;
};

