/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "main.hpp"
#include "../aLib/aMode/aMode.hpp"

class c_iface_def : public aMode {
    int init();

    int entry();
    int close();
    
    int evaluate(int time);
    int render();
    
    public:
        float left_bat_charge[4];
        float left_quad_bar[8];

        float right_top;
        float right_x, right_y, right_z;

        char szNahore[256];
        char szDole  [256];
        
        bool b_slunce_vybrane;
        
        struct t_selektor {
            bool enabled;
            float time;
            float length;
            
            aPath apPos;
            aPath apAlpha;

            float sndpt;
            bool sndptpassed;
            
            char name[256];
        
            t_selektor() {
                reset();
            };
            
            int reset() {
                enabled = false;
                time = 0.0;
                sndptpassed = false;
                sndpt = 2.0;
                return 0;
            }
        } selektor[8];
        
        
        float tab_alpha;
        unsigned int tab_texture;
        char szTab[32][256];
        
        float progress_alpha;
        float progress;
        
        float black;
        
        struct __pad {
            float alpha;
            unsigned int texture;
            char sz[64];
        } pad[4];
        
};

extern c_iface_def iface_def;

