/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "iface_init.hpp"

FSOUND_SAMPLE *iface_init_snd[4];
bool iface_init_prepnuto = false;
bool iface_init_pip[4] = {false,false,false,false};

char szIntroText[] = "Solar System\0";

int c_iface_init::init() {
    aBitmapGL galaxie;

    iface_init_snd[0] = FSOUND_Sample_Load( FSOUND_FREE, "data/snd0.ogg",
                                            FSOUND_NORMAL, 0, 0 );
//    iface_init_snd[1] = FSOUND_Sample_Load( FSOUND_FREE, "data/snd1.ogg",
//                                            FSOUND_NORMAL, 0, 0 );

    return 0;
};

int c_iface_init::entry() {
    lParam = -4000;
    iface_init_prepnuto = false;
    
    FSOUND_PlaySound( FSOUND_FREE, iface_init_snd[0] );
    return 0;
};

int c_iface_init::close() {
    return 0;
};

int c_iface_init::evaluate(int time) {
    lParam += time;

    if (lParam > 3*maxx && !iface_init_prepnuto) {
        iface = 2;
        iface_init_prepnuto = true;
    }
    
    return 0;
};

int c_iface_init::render() {
    glPushAttrib( GL_COLOR_BUFFER_BIT|GL_CURRENT_BIT|GL_ENABLE_BIT );
 
    glLoadIdentity();
    glDisable(GL_LIGHTING);
    
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glEnable(GL_COLOR_MATERIAL);
    glEnable(GL_LINE_SMOOTH);
    glLineWidth(2.8f);
    
    if (lParam < 0) {
        float t = (lParam+4000.0f)/2000.0f;
        
        char szcur[256]; ZeroMemory(szcur, 256);
        strncpy(szcur, szIntroText, (int)((25.0*t)<?strlen(szIntroText)));
        szcur[strlen(szcur)] = '_';

        if (t > 1.0) glColor4f(0.0,0.0,0.0, (2.0-t)/4.0);
                else glColor4f(0.0,0.0,0.0, 0.25);
        aGLPrintf(hAGL, bigfont, maxx/3+2, maxy/2+2, szcur);
        aGLPrintf(hAGL, bigfont, maxx/3+2, maxy/2-2, szcur);
        aGLPrintf(hAGL, bigfont, maxx/3-2, maxy/2-2, szcur);
        aGLPrintf(hAGL, bigfont, maxx/3-2, maxy/2+2, szcur);

        if (t > 1.0) glColor4f(1.0,1.0,1.0, 2.0-t);
                else glColor4f(1.0,1.0,1.0, 1.0);
        aGLPrintf(hAGL, bigfont, maxx/3, maxy/2, szcur);
    };

    // pruhy s 0.5 cernoty :-)
    glColor4f(0.0,0.0,0.0, 0.5);
    glRecti( 0, 0, maxx, (50*lParam/maxx)<?50 ); // nahore a dole
    glRecti( 0, maxy-((50*lParam/maxx)<?50), maxx, maxy );

    glColor4f(1.0,0.8,0.0, 0.9);
    glBegin(GL_LINES);
        glVertex2i(0,50); glVertex2i(lParam<maxx?lParam:maxx,50);
        glVertex2i(lParam<maxx?maxx-lParam:0,maxy-50); glVertex2i(maxx,maxy-50);
        
        int num = 0;
        
        if (lParam > maxx) {
            num = (lParam - maxx)/10;
            if (num > 100) num = 100;
        }
        
        for (int i=1; i<num; ++i) { // carky po okrajich
            int j = (i%5)?8:16;
            float p = ((float)i/100.0f)*(maxy-100)+50.0f;
            
            glVertex2f(0,maxy-p);    glVertex2f(j,maxy-p);
            glVertex2f(maxx,p); glVertex2f(maxx-j,p);
        }

        // vlevo nahore
        float vnal = (float)lParam / ((float)maxx * 2.0f);
        if (vnal > 1.0) vnal = 1.0;
        
        glColor4f(1.0,0.8,0.0, 0.9*vnal);glVertex2i(36,76);
            glColor4f(1.0,0.8,0.0, 0.0); glVertex2i(296,76);
        glColor4f(1.0,0.8,0.0, 0.9*vnal);glVertex2i(36,76);
            glColor4f(1.0,0.8,0.0, 0.0); glVertex2i(36,116);

            glColor4f(1.0,0.8,0.0, 0.9*vnal);
            glVertex2i(208,maxy-10); glVertex2i(208,maxy-42);
            glVertex2i(208,maxy-42); glVertex2i(maxx-208,maxy-42);
            glVertex2i(maxx-208,maxy-42); glVertex2i(maxx-208,maxy-10);

        // podtrzeni hlasky
        if (lParam > maxx) {
            float vnal = (float)(lParam-maxx) / ((float)maxx * 2.0f);
            if (vnal < 0.0) vnal = 0.0;
            if (vnal > 1.0) vnal = 1.0;
    
            glVertex2i(20,maxy-50); glVertex2i(30,maxy-60);
            glVertex2i(30,maxy-60); glColor4f(1.0,0.8,0.0, 0.0);
            glVertex2i(maxx/2,maxy-60); glColor4f(1.0,0.8,0.0, 0.9*vnal);

        // pro fps
        glVertex2i(maxx-400,50); glVertex2i(maxx-380,70);
        glVertex2i(maxx-380,70); glColor4f(1.0,0.8,0.0, 0.0); glVertex2i(maxx-180,70);
        glColor4f(1.0,0.8,0.0, 0.9*vnal);
        }

        for (int i=0; i<6; ++i) {
            glColor4f(1.0,0.8,0.0, 0.9);
            glVertex2i(maxx, 16+4*i);

            int val = (int)(250.0f*((((float)0.5*lParam/(float)maxx)<?1.0f)
                    + 0.1f*sin( 0.01f*(lParam + 360.0f*i) )));
            glColor4f(1.0,0.8,0.0, 0.4);
            glVertex2i(maxx - val + 50, 16+4*i);
        }
    glEnd();
    glColor4f(1.0,0.8,0.0, 0.9);

    // vlevo dole
    for (int i=0; i<((4*lParam/maxx)<?4); ++i) {
        glBegin(GL_LINE_LOOP);
            glVertex2i(48*i+8,maxy-42); glVertex2i(48*i+40,maxy-42);
            glVertex2i(48*i+40,maxy-10); glVertex2i(48*i+8,maxy-10);
        glEnd();
    }
    // vlevo nahore
    for (int i=0; i<(((16*lParam/maxx)-32)<?8); ++i) {
        glColor4f(1.0,0.8,0.0, 0.9);
        glBegin(GL_LINE_LOOP);
            glVertex2i(48*i+8, 16); glVertex2i(48*i+48,16);
            glVertex2i(48*i+48,32); glVertex2i(48*i+8, 32);
        glEnd();
    }

    if (lParam > 0) {
        glEnable(GL_LINE_SMOOTH);
        glBegin(GL_LINES); 
            float polomer[4] = { 0.01, 0.005, 0.0035, 0.002 };
            glColor4f(1.0,0.8,0.0, (0.5*((float)lParam/(float)maxx)) <? 0.5);
            for (int i=216; i<(maxx<?lParam)-216; i+=16) {
                glVertex2i(i,maxy-24); glVertex2i(i+16,maxy-24);
            };
        glEnd();
        glDisable(GL_LINE_SMOOTH);
    }

    glLineWidth(1.0f);
    glDisable(GL_LINE_SMOOTH);
    glColor4f(1.0,0.8,0.0, 0.9);
    glBegin(GL_LINES); 
        glVertex2i(-1,46);
        glVertex2i((lParam<maxx)?lParam:maxx,46); // oddelovace nahore
//        glVertex2i(0,maxy-45); glVertex2i(maxx,maxy-45); //  a dole

        // vlevo nahore
        if (lParam > maxx) {
            float vnal = (float)(lParam-maxx) / ((float)maxx * 2.0f);
            if (vnal < 0.0) vnal = 0.0;
            if (vnal > 1.0) vnal = 1.0;
            
            glColor4f(1.0,0.8,0.0, 0.9*vnal);
            glVertex2i(40,80); glVertex2i(290,80);
            glVertex2i(40,80); glVertex2i(40,110);
            glVertex2i(300,120); glVertex2i(300,90);
            glVertex2i(300,120); glVertex2i(50,120);
            glVertex2i(290,80); glVertex2i(300,90);
            glVertex2i(40,109); glVertex2i(51,120);
        }
    glEnd();



    glPopAttrib();
    return 0;
};

__export c_iface_init iface_init;


