/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "jupiter.hpp"
#include "koule.hpp"

int jupiter_textura = 0;
int jupiter_textura1 = 0;
float jupiter_otoceni = 0.0;

int InitJupiter() {
    aBitmapGL bitmap;
    
    bitmap.load("data/jupiter.aBitmap");
    jupiter_textura = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawJupiter(float distance, int t) {
    if (distance < 10000.0) distance = 10000.0;
    float vertdiv = 10000.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    
    jupiter_otoceni += 0.002*t;
    
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);
    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, jupiter_textura);

    glRotatef(90.0, -1.0, 0.0, 0.0);
    glRotatef(jupiter_otoceni, 0.0, 0.0, 1.0);
    
    DrawSphere(71.0, (int)(50*vertdiv), (int)(50*vertdiv));

/*    glBindTexture(GL_TEXTURE_2D, jupiter_textura1);

    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glEnable(GL_BLEND);
    glDisable(GL_CULL_FACE);

    glRotatef(10.0*jupiter_otoceni, 0.0, 0.0, 1.0);
    DrawSphere(71.5, (int)(50*vertdiv), (int)(50*vertdiv));
    */
    glPopAttrib();
    return 0;
};
