/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "jupiter_mesice.hpp"
#include "koule.hpp"

int jupiter_mesic_textura[4];
float jupiter_mesic_rozmer[4] = { 1.8, 1.6, 2.7, 2.4 };

int InitJupiterMesice() {
    aBitmapGL bitmap;
    
    bitmap.load("data/io.aBitmap");
    jupiter_mesic_textura[0] = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/europa.aBitmap");
    jupiter_mesic_textura[1] = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/ganymede.aBitmap");
    jupiter_mesic_textura[2] = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/callisto.aBitmap");
    jupiter_mesic_textura[3] = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawJupiterMesic(int i, float distance, int t) {
    if (i < 0 || i > 3) return 0;
    
    if (distance < 500.0) distance = 500.0;
    float vertdiv = 500.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);
    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, jupiter_mesic_textura[i]);
    glDisable(GL_BLEND);

    glRotatef(90.0, -1.0, 0.0, 0.0);
    glColor4f(1.0,1.0,1.0,1.0);
    DrawSphere(jupiter_mesic_rozmer[i], (int)(30*vertdiv), (int)(30*vertdiv));
    
    glPopAttrib();
    return 0;
};
