/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "merkur.hpp"
#include "koule.hpp"

int merkur_textura = 0;
float merkur_rotace = 0.0;

int InitMerkur() {
    aBitmapGL bitmap;
    
    bitmap.load("data/merkur.aBitmap");
    merkur_textura = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawMerkur(float distance, int t) {
    merkur_rotace += 0.0001*t;

    if (distance < 500.0) distance = 500.0;
    float vertdiv = 500.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;

    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);

    glColor3f(1.0,1.0,1.0);
    glEnable(GL_TEXTURE_2D);

    glRotatef(merkur_rotace, 0.0, 1.0, 0.0);
    glRotatef(90.0, 1.0, 0.0, 0.0);
    glBindTexture(GL_TEXTURE_2D, merkur_textura);
    DrawSphere(2.5, (int)(30*vertdiv), (int)(30*vertdiv));

    glPopAttrib();
    return 0;
};

