/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "neptun.hpp"
#include "koule.hpp"

int neptun_textura = 0;
int neptun_textura_p = 0;
float neptun_rot = 0.0;

int InitNeptun() {
    aBitmapGL bitmap;
    
    bitmap.load("data/neptun.aBitmap");
    neptun_textura = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/neptun1.aBitmap");
    neptun_textura_p = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawNeptun(float distance, int t) {
    if (distance < 500.0) distance = 500.0;
    float vertdiv = 500.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    neptun_rot += 0.005*t;
    
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);
    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, neptun_textura);
    glDisable(GL_BLEND);

    glRotatef(90.0, -1.0, 0.0, 0.0);
    glColor4f(1.0,1.0,1.0,1.0);
    glRotatef(neptun_rot, 0.0,0.0,1.0);
    DrawSphere(24.7, (int)(50*vertdiv), (int)(50*vertdiv));

    glDisable(GL_CULL_FACE);

    glBindTexture(GL_TEXTURE_2D, neptun_textura_p);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND); 
    
    glDisable(GL_LIGHTING);
    glEnable(GL_COLOR_MATERIAL);
    glColor4f(0.7,0.8,1.0,0.3);

    // prstence
    glBegin(GL_QUADS);
    for (int i=0; i<72; ++i) { // every 5 degree
        glTexCoord2f( 0.0, 0.0 );
        glVertex3f(  41.9 * sin(2.0*PI*(i+0)/72.0),  41.9 * cos(2.0*PI*(i+0)/72.0), 0.0 );
                                                                                 
        glTexCoord2f( 0.0, 1.0 );                                                
        glVertex3f(  41.9 * sin(2.0*PI*(i+1)/72.0),  41.9 * cos(2.0*PI*(i+1)/72.0), 0.0 );
                                                                                 
        glTexCoord2f( 1.0, 1.0 );                                                
        glVertex3f(  63.0 * sin(2.0*PI*(i+1)/72.0),  63.0 * cos(2.0*PI*(i+1)/72.0), 0.0 );
                                                                                 
        glTexCoord2f( 1.0, 0.0 );                                                
        glVertex3f(  63.0 * sin(2.0*PI*(i+0)/72.0),  63.0 * cos(2.0*PI*(i+0)/72.0), 0.0 );
    }
    glEnd();
    
    
    glPopAttrib();
    return 0;
};
