/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "saturn.hpp"
#include "koule.hpp"

int saturn_textura = 0;
int saturn_textura_p = 0;
float saturn_otoceni = 0.0;

int InitSaturn() {
    aBitmapGL bitmap;
    
    bitmap.load("data/saturn.aBitmap");
    saturn_textura = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/saturn1.aBitmap");
    saturn_textura_p = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawSaturn(float distance, int t) {
    if (distance < 10000.0) distance = 10000.0;
    float vertdiv = 10000.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    
    saturn_otoceni += 0.01*t;
    
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);
    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, saturn_textura);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glDisable(GL_BLEND);

    glRotatef(90.0, -1.0, 0.0, 0.0);
    
    glRotatef(saturn_otoceni, 0.0, 0.0, 1.0);
    DrawSphere(60.0, (int)(50*vertdiv), (int)(50*vertdiv));
    
    glDisable(GL_CULL_FACE);

    DrawSphere(60.5, (int)(50*vertdiv), (int)(50*vertdiv));
    
    glBindTexture(GL_TEXTURE_2D, saturn_textura_p);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND); 
    
    glDisable(GL_LIGHTING);
    glColor4f(0.7,0.65,0.6,0.7);

    // prstence
    glBegin(GL_QUADS);
    for (int i=0; i<144; ++i) { // every 5 degree
        glTexCoord2f( 0.0, 0.0 );
        glVertex3f( 67.0 * sin(2.0*PI*(i+0)/144.0), 67.0 * cos(2.0*PI*(i+0)/144.0), 0.0 );
                                                                                 
        glTexCoord2f( 0.0, 1.0 );                                                
        glVertex3f( 67.0 * sin(2.0*PI*(i+1)/144.0), 67.0 * cos(2.0*PI*(i+1)/144.0), 0.0 );
                                                                                 
        glTexCoord2f( 1.0, 1.0 );                                                
        glVertex3f( 180.0 * sin(2.0*PI*(i+1)/144.0), 180.0 * cos(2.0*PI*(i+1)/144.0), 0.0 );
                                                                                 
        glTexCoord2f( 1.0, 0.0 );                                                
        glVertex3f( 180.0 * sin(2.0*PI*(i+0)/144.0), 180.0 * cos(2.0*PI*(i+0)/144.0), 0.0 );
        
    }
    glEnd();
    
    glPopAttrib();
    return 0;
};
