/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "scene_galaxy.hpp"

int scene_galaxy_texture = 0;

struct scene_galaxy_data {
    float rotation;
    float timer;
    bool prepnuto;

    scene_galaxy_data() {
        rotation = 0.0;
        timer = 0.0;
        prepnuto = false;
        return;
    };
};

int c_scene_galaxy::init() {
    aBitmapGL galaxie;

    galaxie.load("data/galaxy.aBitmap");
    scene_galaxy_texture = galaxie.getOpenGLTexture();
    
    return 0;
};

int c_scene_galaxy::entry() {
    data = new scene_galaxy_data;
    FSOUND_SetVolume(0,0);
    return 0;
};

int c_scene_galaxy::close() {
    delete (scene_galaxy_data*)data;
    return 0;
};

int c_scene_galaxy::evaluate(int time) {
    scene_galaxy_data *data = (scene_galaxy_data*) this->data;

    data->rotation += (float)time/1000.0;
    data->timer += (float)time/1000.0;
    
    if (data->timer > 26.0 && !data->prepnuto) { // sekundy
        effect = 1;
        data->prepnuto = true; // efekt zapnut, nezkouset znova
    }

    if (zmenit_pohled) {
        zmenit_pohled = false;
        scene = 2; // solar system
    }
    
    return 0;
};

int c_scene_galaxy::render() {
    scene_galaxy_data *data = (scene_galaxy_data*) this->data;
    
    if (data->timer < 6.0)
        glColor3f( data->timer/6.0, data->timer/6.0, data->timer/6.0 );
    else
        glColor3f( 1.0, 1.0, 1.0 );
    
    glLoadIdentity();
    glEnable(GL_TEXTURE_2D);
    glTranslatef( 0.0, 0.0, -16.0);
    glRotatef( 30.0, -1.0, 1.0, 0.0 );
    glRotatef( data->rotation, 0.0, 0.0, 1.0 );
    
    glBindTexture(GL_TEXTURE_2D, scene_galaxy_texture);
    glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -10.0, -10.0, 0.0 );
		glTexCoord2f(0.0f, 1.0f); glVertex3f(  10.0, -10.0, 0.0 );
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  10.0,  10.0, 0.0 ); 
		glTexCoord2f(1.0f, 0.0f); glVertex3f( -10.0,  10.0, 0.0 );
    glEnd();
        
    return 0;
};

__export c_scene_galaxy scene_galaxy;


