/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "scene_restart.hpp"
#include "iface_def.hpp"

float restart_text_alpha = 0.0;

int c_scene_restart::init() {
    return 0;
};

int c_scene_restart::entry() {
    lParam = 0;

    iface_def.right_x = 0.0;
    iface_def.right_y = 0.0;
    iface_def.right_z = 0.0;
    
    return 0;
};

int c_scene_restart::close() {
    return 0;
};

int c_scene_restart::evaluate(int time) {
    lParam += time;
    
    if (lParam > 1000 && lParam < 2000) {
        restart_text_alpha = (lParam-1000)/1000.0;
    } else
    if (lParam >= 2000 && lParam <= 3000) {
        restart_text_alpha = 1.0;
    } else
    if (lParam > 3000 && lParam < 4000) {
        restart_text_alpha = 1.0-(lParam-3000)/1000.0;
    } else
        restart_text_alpha = 0.0;
    
    if (lParam > 7000) {
        scene = 1;
        iface = 1;
    }
    
    return 0;
};

int c_scene_restart::render() {
    aGL2D(hAGL);
    glEnable(GL_BLEND);

    glColor4f(1.0,1.0,1.0,restart_text_alpha);
    aGLPrintf(hAGL, sysfont, 10, maxy-10, " 2004, Jan Ringo, Tringi@Mx-3.cz");
    
    return 0;
};

__export c_scene_restart scene_restart;


