/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "selektor.hpp"

#define SIZE 24

int DrawSelektor( int x, int y, const char *sz ) {
    float color[4];
    
    glGetFloatv(GL_CURRENT_COLOR, color);
    glColor4f(0.0,0.0,0.0, color[3]/3.0);
    
    glBegin(GL_QUADS);
        glVertex2i( x - SIZE, y - SIZE );
        glVertex2i( x + SIZE, y - SIZE );
        glVertex2i( x + SIZE, y + SIZE );
        glVertex2i( x - SIZE, y + SIZE );
    glEnd();

    glColor4f(color[0], color[1], color[2], color[3]);

    glBegin(GL_LINE_LOOP); 
        glVertex2i( x - SIZE, y - SIZE );
        glVertex2i( x + SIZE, y - SIZE );
        glVertex2i( x + SIZE, y + SIZE );
        glVertex2i( x - SIZE, y + SIZE );
    glEnd();
    
    glBegin(GL_LINES);
        // horizontalni cary
        glColor4f(0.0,0.0,0.0,0.0); 
            glVertex2i( 0     , y      );
        glColor4f(color[0], color[1], color[2], color[3]);
            glVertex2i( x - (SIZE+6), y      );

        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( maxx  , y      );
        glColor4f(color[0], color[1], color[2], color[3]);
            glVertex2i( x + (SIZE+6), y      );
    
        // vertikalni cary
        glColor4f(0.0,0.0,0.0,0.0); 
            glVertex2i( x     , 0      );
        glColor4f(color[0], color[1], color[2], color[3]);
            glVertex2i( x     , y - (SIZE+6) );

        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x     , maxy   );
        glColor4f(color[0], color[1], color[2], color[3]);
            glVertex2i( x     , y + (SIZE+6) );
    
        // male carecky po stranach
        // navrchu        
        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x - (SIZE+6), y - (SIZE+6) );
        glColor4f(color[0], color[1], color[2], color[3]);
            glVertex2i( x           , y - (SIZE+6) );
            glVertex2i( x           , y - (SIZE+6) );
        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x + (SIZE+6), y - (SIZE+6) );

        // dole        
        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x - (SIZE+6), y + (SIZE+6) );
        glColor4f(color[0], color[1], color[2], color[3]);
            glVertex2i( x           , y + (SIZE+6) );
            glVertex2i( x           , y + (SIZE+6) );
        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x + (SIZE+6), y + (SIZE+6) );
            
        // vlevo
        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x - (SIZE+6), y - (SIZE+6) );
        glColor4f(color[0], color[1], color[2], color[3]);
            glVertex2i( x - (SIZE+6), y            );
            glVertex2i( x - (SIZE+6), y            );
        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x - (SIZE+6), y + (SIZE+6) );

        // vpraco
        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x + (SIZE+6), y - (SIZE+6) );
        glColor4f(color[0], color[1], color[2], color[3]);
            glVertex2i( x + (SIZE+6), y            );
            glVertex2i( x + (SIZE+6), y            );
        glColor4f(0.0,0.0,0.0,0.0);
            glVertex2i( x + (SIZE+6), y + (SIZE+6) );

    glEnd();
    
    if (sz)
        if (sz[0]) {
            glColor4f(0.0,0.0,0.0,color[3]);
                aGLPrintf(hAGL, font, x + SIZE + 16 + 1, y + SIZE + 1, sz);
            glColor4f(color[0], color[1], color[2], color[3]);
                aGLPrintf(hAGL, font, x + SIZE + 16, y + SIZE, sz);
        }
    glColor4f(color[0], color[1], color[2], color[3]);

    return 0;
};

