/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "slunce.hpp"
#include "koule.hpp"
#include "billboard.hpp"
#include "particle.hpp"

int slunce_tex[16];
int slunce_live = 0;
int slunce_vnitrek = 0;
int slunce_vnitrek2 = 0;
int slunce_exploze = 0;

int InitSlunce() {
    aBitmapGL bitmap;
    
    bitmap.load("data/slunce01.aBitmap");
    slunce_tex[0] = bitmap.getOpenGLMipmapTexture();
    
    bitmap.load("data/flare.aBitmap");
    slunce_tex[8] = bitmap.getOpenGLMipmapTexture();
    
    slunce_vnitrek = StartSpray((VECTOR3D){0,0,0}, (VECTOR3D){1,1,1}, 1000.0, 
                                5.0, 0.0, 0.9982, 750.0, 8.0 );

    return 0;
};

int DrawSlunce(float distance, int t, bool halo) {
    slunce_live += t;

    if (distance < 100000.0) distance = 100000.0;
    float vertdiv = 100000.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    float mm = 1.0 - (vertdiv - 0.2);

    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);

    glDisable(GL_LIGHTING);
    glEnable(GL_TEXTURE_2D);
//    glColor3f(0.4,0.4,0.4);

    glPushMatrix();
    glPushMatrix();

    glColor3f(0.2,0.2,0.2);
    glBindTexture(GL_TEXTURE_2D, slunce_tex[0]);
    
    if (vertdiv > 0.25) {
        glRotatef(slunce_live*0.001, 0.0, 0.0, 1.0);
        glRotatef(90.0, 1.0, 0.0, 0.0);
        DrawSphere(695, (int)(vertdiv*60), (int)(vertdiv*60));
    
        glDisable(GL_DEPTH_TEST);
        glEnable(GL_BLEND);
    
        for (int i=0; i<6; ++i) {
            glRotatef(126.0+slunce_live*0.001, 0.0, 0.0, 1.0);
            glRotatef(90.0, 1.0, 0.0, 0.0);

            DrawSphere(695+5*i, (int)(vertdiv*60), (int)(vertdiv*60));
        }
    }
    
    glDisable(GL_DEPTH_TEST);
    glEnable(GL_BLEND);

    glPopMatrix();
    if (halo) {
        BillboardSphericalBegin();
        
        glColor3f(mm, mm, mm);
        glBindTexture(GL_TEXTURE_2D, slunce_tex[8]);
        glBegin(GL_QUADS);
            glTexCoord2f(0.0f, 0.0f); glVertex3f(-3000.0, -3000.0, 0.0);
            glTexCoord2f(0.0f, 1.0f); glVertex3f(-3000.0,  3000.0, 0.0);
            glTexCoord2f(1.0f, 1.0f); glVertex3f( 3000.0,  3000.0, 0.0);
            glTexCoord2f(1.0f, 0.0f); glVertex3f( 3000.0, -3000.0, 0.0);
        glEnd();
        
        BillboardSphericalEnd();
    }
    //*/
    glPopMatrix();

    glDisable(GL_DEPTH_TEST);
    glEnable(GL_BLEND);

    ComputeSpray(slunce_vnitrek, t);
    
    glColor3f(0.2, 0.15, 0.12);
    DrawSpray(slunce_vnitrek);

    glEnable(GL_DEPTH_TEST);
    glDisable(GL_BLEND);


    glPopAttrib();
    return 0;
};


