/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "uran.hpp"
#include "koule.hpp"

int uran_textura = 0;
int uran_textura_p = 0;
float uran_rot = 0.0;

int InitUran() {
    aBitmapGL bitmap;
    
    bitmap.load("data/uran.aBitmap");
    uran_textura = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/uran1.aBitmap");
    uran_textura_p = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawUran(float distance, int t) {
    if (distance < 500.0) distance = 500.0;
    float vertdiv = 500.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    uran_rot += 0.005*t;
    
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);
    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, uran_textura);
    glDisable(GL_BLEND);

    glRotatef(90.0, -1.0, 0.0, 0.0);
    glColor4f(1.0,1.0,1.0,1.0);
    glRotatef(uran_rot, 0.0, 0.0, 1.0);
    DrawSphere(25.5, (int)(50*vertdiv), (int)(50*vertdiv));

    glDisable(GL_CULL_FACE);

    glBindTexture(GL_TEXTURE_2D, uran_textura_p);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND); 
    
    glDisable(GL_LIGHTING);
    glEnable(GL_COLOR_MATERIAL);
    glColor3f(0.7,0.8,1.0);

    // prstence
    glBegin(GL_QUADS);
    for (int i=0; i<72; ++i) { // every 5 degree
        glTexCoord2f( 0.0, 0.0 );
        glVertex3f( 38 * sin(2.0*PI*(i+0)/72.0), 38 * cos(2.0*PI*(i+0)/72.0), 0.0 );
                                                                                 
        glTexCoord2f( 0.0, 1.0 );                                                
        glVertex3f( 38 * sin(2.0*PI*(i+1)/72.0), 38 * cos(2.0*PI*(i+1)/72.0), 0.0 );
                                                                                 
        glTexCoord2f( 1.0, 1.0 );                                                
        glVertex3f( 51 * sin(2.0*PI*(i+1)/72.0), 51 * cos(2.0*PI*(i+1)/72.0), 0.0 );
                                                                                 
        glTexCoord2f( 1.0, 0.0 );                                                
        glVertex3f( 51 * sin(2.0*PI*(i+0)/72.0), 51 * cos(2.0*PI*(i+0)/72.0), 0.0 );
        
    }
    glEnd();
    
    
    glPopAttrib();
    return 0;
};
