/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "uran_mesice.hpp"
#include "koule.hpp"

int uran_mesic_textura[4];
float uran_mesic_rozmer[4] = { 0.6, 0.7, 0.8, 0.8 };

int InitUranMesice() {
    aBitmapGL bitmap;
    
    bitmap.load("data/ariel.aBitmap");
    uran_mesic_textura[0] = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/umbriel.aBitmap");
    uran_mesic_textura[1] = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/titania.aBitmap");
    uran_mesic_textura[2] = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/oberon.aBitmap");
    uran_mesic_textura[3] = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawUranMesic(int i, float distance, int t) {
    if (i < 0 || i > 3) return 0;
    
    if (distance < 500.0) distance = 500.0;
    float vertdiv = 500.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    
    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);
    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, uran_mesic_textura[i]);
    glDisable(GL_BLEND);

    glRotatef(90.0, -1.0, 0.0, 0.0);
    glColor4f(1.0,1.0,1.0,1.0);
    DrawSphere(uran_mesic_rozmer[i], (int)(30*vertdiv), (int)(30*vertdiv));
    
    glPopAttrib();
    return 0;
};
