/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "venuse.hpp"
#include "koule.hpp"

int venuse_textura = 0;

int InitVenuse() {
    aBitmapGL bitmap;
    
    bitmap.load("data/venuse.aBitmap");
    venuse_textura = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawVenuse(float distance, int t) {
    if (distance < 500.0) distance = 500.0;
    float vertdiv = 500.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;

    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);

    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, venuse_textura);

    glRotatef(90.0, 1.0, 0.0, 0.0);
    glColor4f(1.0,1.0,1.0,1.0);
    DrawSphere(6.0, (int)(50*vertdiv), (int)(50*vertdiv));
    
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glDisable(GL_CULL_FACE);

    glRotatef(180.0, 0.0, 0.0, 1.0);
    glColor4f(1.0,1.0,1.0,0.5);
    DrawSphere(6.1, (int)(50*vertdiv), (int)(50*vertdiv));

    glDisable(GL_BLEND);

    glPopAttrib();
    return 0;
};

