/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "warp.hpp"
#include "iface_def.hpp"
#include "vypis.hpp"

bool pohled_zmenen = false;
int effect_warp_tex = 0;
FSOUND_SAMPLE *effect_warp_sample;

int c_effect_warp::init() {
    aBitmapGL galaxie;

    galaxie.load("data/warp.aBitmap");
    effect_warp_tex = galaxie.getOpenGLTexture();
    
    effect_warp_sample = FSOUND_Sample_Load( FSOUND_FREE, "data/warp.ogg",
                                             FSOUND_NORMAL, 0, 0 );

    return 0;
};

int c_effect_warp::entry() {
    lParam = 0;
    pohled_zmenen = 0;
    FSOUND_PlaySound( FSOUND_FREE, effect_warp_sample );
    
    Nahoru( "Travelling..." );
    
    return 0;
};

int c_effect_warp::close() {
    Nahoru( "Arrived." );
//    strcpy(iface_def.szNahore, "Arrived");
    return 0;
};

int c_effect_warp::evaluate(int time) {
    lParam += time;
    if (lParam > 3000) effect.set(0);
    
    if (lParam >= 2000 && lParam <= 2500)
        if (!zmenit_pohled && !pohled_zmenen) {
            zmenit_pohled = true;
            pohled_zmenen = true;
        }
    
    return 0;
};

int c_effect_warp::render() {
    float tp = (lParam > 2000)?( 0.05f + 0.45f * ((lParam-2000)/1000.0f)  )
                              :( 0.05f*(lParam/2000.0f) );
    float al = (lParam > 2000)?( 1.0f - ((lParam-2000)/1000.0f)  )
                              :( (lParam/2000.0f) );

    glPushAttrib( GL_COLOR_BUFFER_BIT|GL_CURRENT_BIT|GL_ENABLE_BIT );
 
    glLoadIdentity();
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);

    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);

    glDisable(GL_TEXTURE_2D);
    
    float aal = al;
    if (lParam > 2000) {
        aal *= 2.0;
        if (aal > 1.0) aal = 1.0;
    }
    glColor4f(0.0,0.0,0.0,aal);

    glBegin(GL_QUADS);
   	    glTexCoord2f(       tp,        tp); glVertex2i(    0,    0 );
	    glTexCoord2f(       tp, 1.0f - tp); glVertex2i(    0, maxy );
	    glTexCoord2f(1.0f - tp, 1.0f - tp); glVertex2i( maxx, maxy );
	    glTexCoord2f(1.0f - tp,        tp); glVertex2i( maxx,    0 );
    glEnd();
    
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glEnable(GL_BLEND);
    glEnable(GL_TEXTURE_2D);

    glBindTexture( GL_TEXTURE_2D, effect_warp_tex );
    glColor3f(al,al,al);

    glBegin(GL_QUADS);
   	    glTexCoord2f(       tp,        tp); glVertex2i(    0,    0 );
	    glTexCoord2f(       tp, 1.0f - tp); glVertex2i(    0, maxy );
	    glTexCoord2f(1.0f - tp, 1.0f - tp); glVertex2i( maxx, maxy );
	    glTexCoord2f(1.0f - tp,        tp); glVertex2i( maxx,    0 );
    glEnd();

    glPopAttrib();
    return 0;
};

__export c_effect_warp effect_warp;


