/*
  Name: Space 2004: Solar System
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: This file is part of freeware project.
               Source code is included only for learning purposes.
               
               Consider it to be free to check how things are
               done but not for application in any project (both 
               commercial and non-commercial) without author's
               permission.
*/

#include "zeme.hpp"
#include "koule.hpp"

int zeme_textura = 0;
int zeme_textura_atm = 0;
int zeme_textura_noc = 0;

float zeme_rotace = 0.0;
float zeme_rotace_atm = 0.0;

int InitZeme() {
    aBitmapGL bitmap;
    
    bitmap.load("data/earth.aBitmap");
    zeme_textura = bitmap.getOpenGLMipmapTexture();

    bitmap.load("data/earth1.aBitmap");
    zeme_textura_atm = bitmap.getOpenGLMipmapTexture();

    return 0;
};

int DrawZeme(float distance, int t) {
    if (distance < 500.0) distance = 500.0;
    float vertdiv = 500.0/distance;
    if (vertdiv < 0.2) vertdiv = 0.2;
    
    zeme_rotace += 0.0001*t;
    zeme_rotace_atm += 0.0002*t;

    glPushAttrib(GL_ENABLE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT|GL_COLOR_BUFFER_BIT);

    glEnable(GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, zeme_textura);
    glDisable(GL_BLEND);

    glRotatef(90.0, -1.0, 0.0, 0.0);
    glRotatef(zeme_rotace, 0.0, 0.0, 1.0);
    glColor4f(1.0,1.0,1.0,1.0);
    DrawSphere(6.3, (int)(50*vertdiv), (int)(50*vertdiv));
    
//    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
    glEnable(GL_BLEND);
    glDisable(GL_CULL_FACE);

    glBindTexture(GL_TEXTURE_2D, zeme_textura_atm);

    glRotatef(zeme_rotace_atm, 0.0, 0.0, 1.0);
    glColor4f(0.95,0.95,1.0,1.0);
    DrawSphere(6.4, (int)(50*vertdiv), (int)(50*vertdiv));

    glDisable(GL_BLEND);

    glPopAttrib();
    return 0;
};

