/*
  Name: a3Dmath.hpp
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: a3Dmath vertor library

  Requirements: Windows Environment
  Handling: 3D calculations

  This is not official version of the code.
*/
#ifndef __A3DMATH_HPP__
#define __A3DMATH_HPP__
 
#include <math.h>

#define PI 3.1415926535897932
#define _abs(x) ((x<0)?(-(x)):(x))

struct __attribute__((aligned(16))) VECTOR3D {
    float x,y,z,w;
}; // aligned
struct __attribute__((aligned(16))) DVECTOR3D {
    double x, y, z, w;
};


/*
typedef union __VF {  
    VECTOR3D vector3d;
    float xyz[4]; // to be aligned
    struct {
        float x;
        float y;
        float z;
        float w;
    };
} VF;
*/
extern VECTOR3D Cross(VECTOR3D vVector1, VECTOR3D vVector2) __attribute__ ((pure,noinline));
extern VECTOR3D Vector(VECTOR3D vPoint1, VECTOR3D vPoint2) __attribute__ ((pure,noinline));
extern float Magnitude(VECTOR3D vNormal) __attribute__ ((pure,noinline));
extern VECTOR3D Normalize(VECTOR3D vNormal)  __attribute__ ((pure,noinline));
extern VECTOR3D Normal(VECTOR3D vTriangle[])  __attribute__ ((pure,noinline));
extern VECTOR3D Normal3(VECTOR3D a,VECTOR3D b,VECTOR3D c)  __attribute__ ((pure,noinline));
extern float PlaneDistance(VECTOR3D Normal, VECTOR3D Point) __attribute__ ((pure,noinline));
extern bool IntersectedPlane(VECTOR3D vPoly[], VECTOR3D vLine[], 
                             VECTOR3D &vNormal, float &originDistance);
extern float Dot(VECTOR3D vVector1, VECTOR3D vVector2) __attribute__ ((pure,noinline));
extern double AngleBetweenVectors(VECTOR3D Vector1, VECTOR3D Vector2)
               __attribute__ ((pure));
extern VECTOR3D IntersectionPoint(VECTOR3D vNormal, VECTOR3D vLine[], double distance);
extern bool InsidePolygon(VECTOR3D vIntersection, VECTOR3D Poly[], long verticeCount);
extern float IntersectedPolygon(VECTOR3D vPoly[], VECTOR3D vLine[], int verticeCount);
extern float IntersectionDist(VECTOR3D vNormal, VECTOR3D vLine[], double distance);

extern float PointDistance(VECTOR3D pt1, VECTOR3D pt2);
extern double PointDistance(DVECTOR3D pt1, DVECTOR3D pt2);


#endif

