/*
  Name: aBitmapGL.cpp
  Copyright: Copyright(C) 2004, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: Extends aBitmap of OpenGL support
  
  This is not official version of the code.
*/

#include "aBitmapGL.hpp"

int aBitmapGL::getOpenGLDisplayList() {
    unsigned int textura = 0;
    unsigned int list = 0;
    int i,j;
 
    list = glGenLists(1);
    
    textura = getOpenGLTexture();

    // TODO: udelat ,...); funkci abych nemusel prepocitavat truexy
    int truex=1024,truey=1024;
    for (i=2;i<10;i++) if ((1<<i)>=(sizex)) { truex=(1<<i); break; }
    for (i=2;i<10;i++) if ((1<<i)>=(sizey)) { truey=(1<<i); break; }

    glLoadIdentity();
    glNewList(list,GL_COMPILE);
  	    glPushAttrib( GL_COLOR_BUFFER_BIT|GL_CURRENT_BIT|GL_ENABLE_BIT);
        glColor3f(1.0,1.0,1.0);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
        glEnable(GL_BLEND);
        glEnable(GL_TEXTURE_2D);
        glDisable(GL_LIGHTING);
        glBindTexture(GL_TEXTURE_2D, textura);
        glBegin(GL_QUADS);
       	    glTexCoord2f(0.0f,  0.0f);                      glVertex2i( 0, 0);
    	    glTexCoord2f(0.0f,  (float)sizey/(float)truey); glVertex2i( 0, 1);
    	    glTexCoord2f((float)sizex/(float)truex,
                         (float)sizey/(float)truey); glVertex2i( 1, 1);
    	    glTexCoord2f((float)sizex/(float)truex,  0.0f); glVertex2i( 1, 0);
        glEnd();
      	glPopAttrib();
    glEndList();  
    
    return list;
}

int aBitmapGL::getOpenGLTexture(bool border) {
    unsigned int textura = 0;
    unsigned int i,j;
    glGenTextures(1, &textura);
    glLoadIdentity();
    glBindTexture(GL_TEXTURE_2D, textura);
    
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
//    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
//    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

    // zjistit nejblizsi vyssi
    int truex=2048,truey=2048;
    
    for (i=2;i<11;++i) if ((1<<i)>=(sizex)) { truex=(1<<i); break; }
    for (i=2;i<11;++i) if ((1<<i)>=(sizey)) { truey=(1<<i); break; }
    
    // rescale
    __rgba *t = (__rgba*)GlobalAlloc(GPTR,truex*truey*sizeof(__rgba));
    ZeroMemory(t,sizeof(__rgba)*truex*truey);
    
    // FIXME: Bylo-li volano getOpenGLDisplayList, pri j==1 pada s
    //        hlaskou: Pamet nemuze byt READ.
    for (j=0;j<sizey;j++) CopyMemory(&t[truex*j],&rgba[sizex*j],4*sizex);

    glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA8,truex,truey,border,
                        GL_RGBA,GL_UNSIGNED_BYTE,t);
/*    FILE *f = fopen("tzzz.txt","at");
    fprintf(f,"%d: %dx%d: %d\n",textura,truex,truey,glGetError());
    fclose(f);//*/

    GlobalFree(t);

    return textura;
}



int aBitmapGL::getOpenGLMipmapTexture() {
    return getOpenGLTexture();
    
    // glu is obsolete
    unsigned int textura = 0;
    unsigned int i,j;
    glGenTextures(1, &textura);

    glBindTexture(GL_TEXTURE_2D, textura);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);

    gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA8,sizex,sizey,
                      GL_RGBA,GL_UNSIGNED_BYTE, rgba);
    return textura;//*/
}



