/*
  Name: aDef.hpp
  Copyright: Copyright(C) 2003, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: aDef support library

  Requirements: aGL graphics library
  Handling: Some support functions for aGL
  
  This is not official version of the code.  
*/
#ifndef __ADEF_HPP__
#define __ADEF_HPP__

#include <stdio.h>

// aGL DEFaults library
#define AGL_ERROR_NOERROR 0

// cannot open file, file does not exist or error reading
#define AGL_ERROR_FILEERR -1
// opening not supported file format
#define AGL_ERROR_BADFILE -2
// unsupported compression
#define AGL_ERROR_COMPRESSION -3
// buffer error in decompression, probably bad input data
// any other buffer errors
#define AGL_ERROR_BUFFER -4
// error in compressed input data, damaged file
#define AGL_ERROR_ZDATA -5
// input file is not complete
#define AGL_ERROR_FILECUT -6
// stream error in compression
#define AGL_ERROR_ZSTREAM -7
// incompatible data
#define AGL_ERROR_COMPAT -8

// not enough memory to proceed
#define AGL_ERROR_MEMORY -9

// bad parameter passed to function
#define AGL_ERROR_BADPARAM -10
// function need to be initialized first
#define AGL_ERROR_NOTINIT -11


// function need to be initialized first
#define AGL_ERROR_UNKNOWN -999


// SUPPORT functions

long filesize(FILE *stream);
int swap(int *a,int *b) __attribute__ ((always_inline));

#endif
