/*
  Name: aFrustum.hpp
  Copyright: Copyright(C) 2003, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: Frustum Culling routines

  Requirements: aGL
  Handling: Frustum Culling
  
  This is not official version of the code.
*/

#ifndef __AFRUSTUM_HPP__
#define __AFRUSTUM_HPP__

#include "a3Dmath.hpp"
#include <gl\gl.h>

void NormalizePlane(float frustum[6][4], int side);

class aFrustum {
    public:
        void CalculateFrustum();
        bool PointInFrustum(float x, float y, float z);
        bool SphereInFrustum(float x, float y, float z, float radius);
        bool CubeInFrustum( float x, float y, float z, float size );
        bool FaceInFrustum(VECTOR3D a, VECTOR3D b, VECTOR3D c);
        bool RectInFrustum(VECTOR3D *body);

    private:
        float m_Frustum[6][4];
};


#endif

