/*
  Name: aMode.hpp
  Copyright: Copyright(C) 2003, Jan Ringos, Tringi@Mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
  Description: aMode base level for game development
  
  This is not official version of the code.
*/

#ifndef __AMODE_HPP
#define __AMODE_HPP

#define AMODE_MAXMODES 65536

// values returned by aState functions
#define AMODE_ERROR_NOERROR             0
#define AMODE_ERROR_INVALIDAMODE     -701
#define AMODE_ERROR_INVALIDPARAM     -702
#define AMODE_ERROR_TABLEFULL        -703
#define AMODE_ERROR_MISSINGMODE      -704
#define AMODE_ERROR_NOMODESELECTED   -705

// values that aMode virtual functions returns
#define AMODE_SIGNAL_SUCCESS            0
#define AMODE_SIGNAL_REQUESTEND      -801
#define AMODE_SIGNAL_SUPPRESSRENDER  -802 // only evaluate
#define AMODE_SIGNAL_REQUESTIMMEND   -803 // REQUEST END and SUPPRESS RENDER - only evaluate

// loop and set function returns these values
#define AMODE_SIGNAL_ENDREQUESTED      -901

#include <windows.h>
#include <stdio.h>

class aState;

class aMode {
    friend class aState;
    
    public:
        aMode() { };
        ~aMode() { };

    private:
        virtual int init();
    
        virtual int entry(); //  __attribute__ ((const))
        virtual int close();
        
        virtual int evaluate(int time);
        virtual int render();

    protected:
        long lParam;
        void *data;        
};

class aState {
    private:
        unsigned int time;
        unsigned int current;
        bool ending;
        
        unsigned int instance;
        
        aMode *mode[AMODE_MAXMODES];
        
        // support fncs
        int request_end();
        
    public:
        aState();
        ~aState(){ };
    
        int Register(aMode *amode);
        int Modify(int pos, aMode *amode = NULL);
        int SetTime(int t);

        int set(int m);
        int Set(register int _m){ this->set(_m); };
      	aState operator=(int m) { this->set(m); };
      	
      	int get();
      	operator int() { return this->get(); }
      	
      	
      	int loop();
};

#endif

