/*
  Name: aPath.hpp
  Copyright: Copyright(C) 2003, Jan Ringos, Tringi@seznam.cz
  Author: Jan Ringos, http://Tringi.CzWeb.org
  Description: Module for examinating linearistic 4D paths 
*/

#ifndef __APATH_HPP
#define __APATH_HPP

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <zlib.h>

class aPath {
    private:
        char magic[8];
        int n;
        int compression;

        double *data; // array of doubles[4]
    public:
        aPath();
        ~aPath();
        
        int reset();
        int load(char*sz);
        int save(char*sz);
        int save_c(char*sz);
        
        int addp(double p, double v1, double v2 = 0.0, 
                           double v3 = 0.0);
        double get(double p, double *v1 = NULL, double *v2 = NULL,
                             double *v3 = NULL);
        float getf(double ps, float *v1 = NULL,float *v2 = NULL,float *v3 = NULL);

        double getsin(double p, double *v1 = NULL, double *v2 = NULL,
                                double *v3 = NULL);

        double getpre(double p, double *v1 = NULL, double *v2 = NULL,
                                double *v3 = NULL);

        int getn();
        double geti(int i,double *p = NULL, double *v1 = NULL, 
                          double *v2 = NULL, double *v3 = NULL);
        int seti(int i, double v1, double v2 = 0.0, double v3 = 0.0);
        int remi(int i);
        
        int arealloc(int);
};

#define APATH_ERROR_FILE    -1
#define APATH_ERROR_MEMORY  -2
#define APATH_ERROR_VERSION -3

#endif

