/*
  Name: aStdEx.cpp
  Copyright: Copyright (C) 2004, Jan Ringo, Tringi@Mx-3.cz
  Author: Jan Ringo, http://Tringi.Mx-3.cz
  Description: aLibrary - a Standard Library Extension
  
  This is not official version of the code.
*/

#include "aStdEx.h"

// data
namespace aStdEx {
    struct {
        const char *file;
        const char *func;
        unsigned int line;
    } err;

};

// allocation
void *alloc(unsigned int len) {
    void *ptr = NULL;
    
    ptr = malloc( len );
    if ( !ptr ) return NULL;
    
    memset( ptr, 0, len );
    return ptr;
};

// files
unsigned int fsize(FILE *f) {
   long curpos, length;

   curpos = ftell(f);
   fseek(f, 0, SEEK_END);
   length = ftell(f);
   fseek(f, curpos, SEEK_SET);
   
   return length;
};

int fungetc(FILE *f) {
   return fseek(f, -1, SEEK_CUR);
};

// errors
unsigned int errpos(const char *file, const char *fnc, unsigned int line) {
    if (!file || !fnc) return 1;
    
    aStdEx::err.file = file;
    aStdEx::err.func = fnc;
    aStdEx::err.line = line;
    
    return 0;
};

unsigned int errbox(int err, const char* fmt) {
    printf("\nError: %d\nIn: %s\tLine: %d\tFunc: %s\nDesc: %s\n\n",
           err, aStdEx::err.file,aStdEx::err.line,aStdEx::err.func, fmt);
    
    return 0;
};


