/*
  Name: aStdEx.h
  Copyright: Copyright (C) 2004, Jan Ringo, Tringi@Mx-3.cz
  Author: Jan Ringo, http://Tringi.Mx-3.cz
  Description: aLibrary - a Standard Library Extension
               This contains only few functions that are used
               in other a's
  
  This is not official version of the code.
*/

#ifndef __ASTDEX_HPP
#define __ASTDEX_HPP

#include <stdlib.h>
#include <stdio.h>
#include <mem.h>

// memory
void *alloc(unsigned int len);

// file handles
unsigned int fsize(FILE *f);
int fungetc(FILE *f);

// errors
unsigned int errpos(const char* file, const char* fnc, unsigned int line);
unsigned int errbox(int err, const char* sz);

#define Err(err, ...)                                              \
 ({ char sz2[4096];                                                \
    sprintf(sz2, __VA_ARGS__);                                     \
    errpos(__FILE__, __PRETTY_FUNCTION__, __LINE__ - 4);           \
    errbox(err, sz2);                                              \
  })                                          


#endif

