/*
  Name: random.hpp
  Copyright: Copyright(C) 2003, Jan Ringos, Tringi@mx-3.cz
  Author: Jan Ringos, http://Tringi.Mx-3.cz
*/

#include "random.hpp"

namespace {
    float u[98], c, cd, cm;
    int i97, j97;
    bool test = false;
};

void rmarin(int ij, int kl) {
	int i, j, k, l, ii, jj, m;
	float s, t;
	
	if (ij<0 || ij>31328) ij = 1802;
    if (kl<0 || kl>30081) kl = 9373;
	
	i = (ij/177)%177 + 2;
	j = ij%177 + 2;
	k = (kl/169)%178 + 1;
	l = kl%169;
	
	for (ii=1; ii<=97; ii++) {
		s = 0.0;
		t = 0.5;
		for (jj=1; jj<=24; jj++) {
			m = (((i*j)%179)*k) % 179;
			i = j;
			j = k;
			k = m;
			l = (53*l + 1) % 169;
			if ((l*m)%64 >= 32) s += t;
			t *= 0.5;
		}
		u[ii] = s;
	}
	
	c = 362436.0 / 16777216.0;
	cd = 7654321.0 / 16777216.0;
	cm = 16777213.0 / 16777216.0;
	
	i97 = 97;
	j97 = 33;
	
	test = true;
	return;
}

float ranmar(){
	int ivec = 1;
	float uni;
	
	if (!test) rmarin(-1,-1); //common init
	
	uni = u[i97] - u[j97];
	if (uni < 0.0) uni += 1.0;
	u[i97] = uni;
	i97--;
	if (i97==0) i97 = 97;
	j97--;
	if (j97==0) j97 = 97;
	c -= cd;
	if (c<0.0) c += cm;
	uni -= c;
	if (uni<0.0) uni += 1.0;
	
	return uni;
}

int random(int i) {
    if (!i) return 0;
    if (i<0) i=-i;

    register float r = ranmar() * i;
    register int s = (int)r;
    
    s = s % i;
    
    return (int)s;
}

