/*
  Name: random.hpp
  Copyright: Copyright(C) 2003, Jan Ringos, Tringi@mx-3.cz
  Author: Jan Ringos, http://Tringi.mx-3.cz
  Description: 

  ************************************************************************
   This random number generator originally appeared in "Toward a Universal
   Random Number Generator" by George Marsaglia and Arif Zaman.
   Florida State University Report: FSU-SCRI-87-50 (1987)

   It was later modified by F. James and published in "A Review of Pseudo-
   random Number Generators"

   Converted from FORTRAN to C by Phil Linttell, James F. Hickling
   Management Consultants Ltd, Aug. 14, 1989.
   For general use modified by Jan Ringos, 2003.

   THIS IS THE BEST KNOWN RANDOM NUMBER GENERATOR AVAILABLE.
         (However, a newly discovered technique can yield
           a period of 10^600. But that is still in the development stage.)

   It passes ALL of the tests for random number generators and has a period
     of 2^144, is completely portable (gives bit identical results on all
     machines with at least 24-bit mantissas in the floating point
     representation).

   The algorithm is a combination of a Fibonacci sequence (with lags of 97
     and 33, and operation "subtraction plus one, modulo one") and an
     "arithmetic sequence" (using subtraction).

   On a Vax 11/780, this random number generator can produce a number in
      13 microseconds.
  ************************************************************************

*/

#ifndef __RANDOM_HPP
#define __RANDOM_HPP

#include <stdio.h>
#include <stdlib.h>

//#define random(num) (int)(((rand())*(long)(num))/(((long)RAND_MAX)+1))
//#define randomize() srand((unsigned)GetTickCount()|1)

#define randomize() rmarin(GetTickCount()%31329,GetTickCount()%30081)

extern void rmarin(int ij, int kl);
extern float ranmar();
extern int random(int);

#endif

